* Note: this program can also run with Form 1, but will possibly
* leave spinor chains not fully simplified

.sort

s r2, CW, SW, C4, S4, C2, S2, EL, a2;

id r2^2 = 2;
id r2^-2 = 1/2;
id CW^-4 = C4;
id SW^-4 = S4;
id CW^-2 = C2;
id SW^-2 = S2;
id EL^4 = 16*Pi^2*a2;

#call mandelstam{}

.sort

i I1, I2, I3, I4;
s M1, M2, M3, M4, X1, X2, nind, unknown;
v P1, P2, P3;
f fc, ga, ga5;
cf DEN, sme, eq, neq;
cf d0, c0, b0, a0, pv, b1, b00, b11, pave3, pave4;
set bcd: b0, c0, d0;


* >>> Dirac algebra for open fermion chains:

id gi_(I1?) = 1;
id Spinor(P1?, M1?) * Spinor(P2?, M2?) =
  sme(Spinor(P1, M1), Spinor(P2, M2));

#if 'VERSION_' == 1

#procedure diracsimplify()
  id ga(P1?) * ga(P1?) = P1.P1;
  id ga(I1?) * ga(I1?) = d_(I1, I1);
  id ga(P1?) * Spinor(P1?, M1?) = M1 * Spinor(P1, M1);
  id Spinor(P1?, M1?) * ga(P1?) = -M1 * Spinor(P1, M1);
  id Spinor(P1?, M1?) * ga5 * ga(P1?) = M1 * Spinor(P1, M1) * ga5;
#endprocedure

id g5_(I1?) = ga5;
id g_(I1?, I2?) = ga(I2);
#call diracsimplify{}

#else

#procedure diracsimplify()
  repeat id fc(X1?) * fc(X2?) = fc(X1 * X2);
  id Spinor(P1?, M1?) * fc(X1?) * Spinor(P2?, M2?) =
    fc(P1, P2,
      Spinor(P1, M1) * X1 * Spinor(P2, M2) * replace_(P1, aa, P2, zz));
  argument, fc;
    repeat id,disorder, ga(I1?) * ga(I2?) =
      2 * d_(I1, I2) - ga(I2) * ga(I1);
    id ga(P1?) * ga(P1?) = P1.P1;
    id ga(I1?) * ga(I1?) = d_(I1, I1);
    id ga(P1?) * Spinor(P1?, M1?) = M1 * Spinor(P1, M1);
    id Spinor(P1?, M1?) * ga(P1?) = -M1 * Spinor(P1, M1);
    id Spinor(P1?, M1?) * ga5 * ga(P1?) = M1 * Spinor(P1, M1) * ga5;
  endargument;
  id fc(P1?, P2?, X1?) = fc(X1 * replace_(aa, P1, zz, P2));
  id fc(X1?) = X1;
#endprocedure

if( count(g_, 1) > 0 );
  id g5_(I1?) = fc(ga5);
  id g_(I1?, I2?) = fc(ga(I2));
#call diracsimplify{}
endif;
#endif


* >>> tensor reduction:

repeat;
  id,once, q1.q1 * pv?bcd(?) = pv(I4, I4, .);
  sum I4;
endrepeat;
repeat;
  id,once, q1.P1? * pv?bcd(?) = d_(P1, I4) * pv(I4, .);
  sum I4;
endrepeat;
repeat;
  id,once, d_(q1, I4?) * pv?bcd(?) = pv(I4, .);
  sum I4;
endrepeat;
repeat;
  id,once, ga(q1) * pv?bcd(?) = ga(I4) * pv(I4, .);
  sum I4;
endrepeat;
repeat;
  id,once, e_(q1, I1?, I2?, I3?) * pv?bcd(?) =
    pv(I4, .) * e_(I4, I1, I2, I3);
  sum I4;
endrepeat;

#if 'VERSION_' == 1
.sort
#else
b b0, c0, d0;
.sort
keep brackets;
#endif

#if 'DIM' == 4
* add local terms for dimred/CDR

id d0(I1?, I2?, I3?, I4?, P1?, P2?, P3?, M1?, M2?, M3?, M4?) =
  d0(I1, I2, I3, I4, P1, P2, P3, M1, M2, M3, M4) -
  eq(e_(I1, I2, I3, I4)) *
    5/144 * (d_(I1, I2) * d_(I3, I4) +
             d_(I1, I3) * d_(I2, I4) +
             d_(I1, I4) * d_(I2, I3)) +
  1/8 * (eq(I1, I2) * neq(I3, I4) + eq(I1, I3) * neq(I2, I4) +
         eq(I1, I4) * neq(I2, I3) + eq(I2, I3) * neq(I1, I4) +
         eq(I2, I4) * neq(I1, I3) + eq(I3, I4) * neq(I1, I2));

id eq(I1?, I1?) = 1;
id neq(I1?, I1?) = 0;
id neq(I1?, I2?) = d_(I1, I2);

id c0(I1?, I2?, I3?, P1?, P2?, M1?, M2?, M3?) =
  c0(I1, I2, I3, P1, P2, M1, M2, M3) +
  eq(e_(I1, I2, I3)) *
    1/36 * (d_(I1, I2) * (d_(P1, I3) + d_(P2, I3)) +
            d_(I1, I3) * (d_(P1, I2) + d_(P2, I2)) +
            d_(I2, I3) * (d_(P1, I1) + d_(P2, I1)));

id c0(I1?, I1?, P1?, P2?, M1?, M2?, M3?) =
  c0(I1, I1, P1, P2, M1, M2, M3) - 1/2;

id eq(0) = 1;
id eq(?) = 0;

id b0(I1?, I1?, P1?, M1?, M2?) = a0(M2) + M1 * b0(P1, M1, M2);
#endif


id d0(I1?, I2?, I3?, I4?, P1?, P2?, P3?, M1?, M2?, M3?, M4?) =
  pave4(0, 0, 0, 0, P1, P2, P3, M1, M2, M3, M4) *
     (d_(I1, I2) * d_(I3, I4) +
      d_(I1, I3) * d_(I2, I4) +
      d_(I1, I4) * d_(I2, I3))
#do i = 1, 3
#do j = 1, 3
  + pave4(0, 0, 'i', 'j', P1, P2, P3, M1, M2, M3, M4) *
     (d_(I1, I2) * d_(P'i', I3) * d_(P'j', I4) +
      d_(I2, I3) * d_(P'i', I1) * d_(P'j', I4) +
      d_(I1, I3) * d_(P'i', I2) * d_(P'j', I4) +
      d_(I1, I4) * d_(P'i', I2) * d_(P'j', I3) +
      d_(I2, I4) * d_(P'i', I1) * d_(P'j', I3) +
      d_(I3, I4) * d_(P'i', I1) * d_(P'j', I2))
#do k = 1, 3
#do l = 1, 3
  + pave4('i', 'j', 'k', 'l', P1, P2, P3, M1, M2, M3, M4) *
      d_(P'i', I1) * d_(P'j', I2) * d_(P'k', I3) * d_(P'l', I4)
#enddo
#enddo
#enddo
#enddo
  ;

id d0(I1?, I2?, I3?, P1?, P2?, P3?, M1?, M2?, M3?, M4?) =
#do i = 1, 3
  + pave4(0, 0, 'i', P1, P2, P3, M1, M2, M3, M4) *
     (d_(I1, I2) * d_(P'i', I3) +
      d_(I2, I3) * d_(P'i', I1) +
      d_(I1, I3) * d_(P'i', I2))
#do j = 1, 3
#do k = 1, 3
  + pave4('i', 'j', 'k', P1, P2, P3, M1, M2, M3, M4) *
      d_(P'i', I1) * d_(P'j', I2) * d_(P'k', I3)
#enddo
#enddo
#enddo
  ;

id d0(I1?, I2?, P1?, P2?, P3?, M1?, M2?, M3?, M4?) =
  pave4(0, 0, P1, P2, P3, M1, M2, M3, M4) * d_(I1, I2)
#do i = 1, 3
#do j = 1, 3
  + pave4('i', 'j', P1, P2, P3, M1, M2, M3, M4) *
      d_(P'i', I1) * d_(P'j', I2)
#enddo
#enddo
  ;

id d0(I1?, P1?, P2?, P3?, M1?, M2?, M3?, M4?) =
#do i = 1, 3
  + pave4('i', P1, P2, P3, M1, M2, M3, M4) * d_(P'i', I1)
#enddo
  ;

id c0(I1?, I2?, I3?, P1?, P2?, M1?, M2?, M3?) =
#do i = 1, 2
  + pave3(0, 0, 'i', P1, P2, M1, M2, M3) *
     (d_(I1, I2) * d_(P'i', I3) +
      d_(I2, I3) * d_(P'i', I1) +
      d_(I1, I3) * d_(P'i', I2))
#do j = 1, 2
#do k = 1, 2
  + pave3('i', 'j', 'k', P1, P2, M1, M2, M3) *
      d_(P'i', I1) * d_(P'j', I2) * d_(P'k', I3)
#enddo
#enddo
#enddo
  ;

id c0(I1?, I2?, P1?, P2?, M1?, M2?, M3?) =
  pave3(0, 0, P1, P2, M1, M2, M3) * d_(I1, I2)
#do i = 1, 2
#do j = 1, 2
  + pave3('i', 'j', P1, P2, M1, M2, M3) * d_(P'i', I1) * d_(P'j', I2)
#enddo
#enddo
  ;

id c0(I1?, P1?, P2?, M1?, M2?, M3?) =
#do i = 1, 2
  + pave3('i', P1, P2, M1, M2, M3) * d_(P'i', I1)
#enddo
  ;

id b0(I1?, I2?, P1?, M1?, M2?) =
  b00(P1, M1, M2) * d_(I1, I2) +
  b11(P1, M1, M2) * d_(P1, I1) * d_(P1, I2);

id b0(I1?, P1?, M1?, M2?) = b1(P1, M1, M2) * d_(P1, I1);

symm pave4:11 1, 2, 3, 4;
symm pave4:10 1, 2, 3;
symm pave4:9 1, 2;
symm pave3:8 1, 2, 3;
symm pave3:7 1, 2;

id c0(P1?, P2?, M1?, M2?, M3?) = pave3(0, P1, P2, M1, M2, M3);
id d0(P1?, P2?, P3?, M1?, M2?, M3?, M4?) =
  pave4(0, P1, P2, P3, M1, M2, M3, M4);

id a0(?, I1?, M1?) = unknown;
id b0(?, I1?, P1?, M1?, M2?) = unknown;
id c0(?) = unknown;
id d0(?) = unknown;

.sort


* >>> Dirac algebra for open fermion chains:

if( count(ga, 1, ga5, 1, Spinor, 1) > 0 );
#if 'VERSION_' > 1
  id ga5 = fc(ga5);
  id ga(I1?) = fc(ga(I1));
#endif

#call diracsimplify{}

  id ga5 = fc(ga5);
  id ga(I1?) = fc(ga(I1));
  repeat id fc(?) * fc(??) = fc(., ..);
  id Spinor(P1?, M1?) * fc(?) * Spinor(P2?, M2?) =
    sme(Spinor(P1, M1), ., Spinor(P2, M2));
  id Spinor(P1?, M1?) * Spinor(P2?, M2?) =
    sme(Spinor(P1, M1), Spinor(P2, M2));
  id fc(?) = sme(.);
endif;


* >>> cleaning up:

#call momcons{}

#if 'DIM' == 0
repeat;
  id,once, D*a0(M1?) = 4*a0(M1) - 2*M1;
  id,once, D*b0(?) = 4*b0(.) - 2;
  id,once, D*b11(?) = 4*b11(.) - 2/3;
  id,once, D*b1(?) = 4*b1(.) + 1;
  id,once, D*b00(P1?, M1?, M2?) =
    4*b00(P1, M1, M2) + 1/6*P1.P1 - 1/2*M1 - 1/2*M2;
  id,once, D*pave3(0, 0, P1?, P2?, M1?, M2?, M3?) =
    4*pave3(0, 0, P1, P2, M1, M2, M3) - 1/2;
#if 'VERSION_' > 1
  id,once, D*pave3(0, 0, I1?, P1?, P2?, M1?, M2?, M3?) =
    4*pave3(0, 0, I1, P1, P2, M1, M2, M3) + 1/6;
#else
  id,once, D*pave3(I1?, 0, 0, P1?, P2?, M1?, M2?, M3?) =
    4*pave3(I1, 0, 0, P1, P2, M1, M2, M3) + 1/6;
#endif
  id,once, D*pave4(0, 0, 0, 0, ?) = 4*pave4(0, 0, 0, 0, .) - 1/12;
endrepeat;
id D = 4;
#endif

#call mandelstam{}

b a0, b0, b1, b00, b11, pave3, pave4, DEN, i_;

print +s amp;

